# MemoryBoard
Date: 2018-12-06

com.massivecraft.factions.zcore.persist

## Class MemoryBoard

- java.lang.Object
- - com.massivecraft.factions.Board
  - - com.massivecraft.factions.zcore.persist.MemoryBoard

Direct Known Subclasses:
  JSONBoard

    public abstract class MemoryBoard
    extends Board

### Nested Class Summary

Nested Classes
`class` `MemoryBoard.MemoryBoardMap`

### Field Summary

Fields
`MemoryBoard.MemoryBoardMap` `flocationIds`

### Fields inherited from class com.massivecraft.factions.Board

`instance`

### Constructor Summary

Constructors
Constructor and Description
`MemoryBoard()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`void` `clean()`
`void` `clean(java.lang.String factionId)`
`void` `clearOwnershipAt(FLocation flocation)`
`abstract void` `convertFrom(MemoryBoard old)`
`java.util.Set<FLocation>` `getAllClaims(Faction faction)`
`java.util.Set<FLocation>` `getAllClaims(java.lang.String factionId)`
`Faction` `getFactionAt(FLocation flocation)`
`int` `getFactionCoordCount(Faction faction)`
`int` `getFactionCoordCount(java.lang.String factionId)`
`int` `getFactionCoordCountInWorld(Faction faction, java.lang.String worldName)`
`java.lang.String` `getIdAt(FLocation flocation)`
`java.util.ArrayList<mkremins.fanciful.FancyMessage>` `getMap(FPlayer fplayer, FLocation flocation, double inDegrees)` The map is relative to a coord and a faction north is in the direction of decreasing x east is in the direction of decreasing z
`boolean` `hasFactionWithin(FLocation flocation, Faction faction, int radius)` Checks if there is another faction within a given radius other than Wilderness.
`boolean` `isBorderLocation(FLocation flocation)`
`boolean` `isConnectedLocation(FLocation flocation, Faction faction)`
`void` `removeAt(FLocation flocation)`
`void` `setFactionAt(Faction faction, FLocation flocation)`
`void` `setIdAt(java.lang.String id, FLocation flocation)`
`void` `unclaimAll(java.lang.String factionId)`
`void` `unclaimAllInWorld(java.lang.String factionId, org.bukkit.World world)`

### Methods inherited from class com.massivecraft.factions.Board

`forceSave, forceSave, getInstance, load`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### flocationIds

    public MemoryBoard.MemoryBoardMap flocationIds

### Constructor Detail

#### MemoryBoard

    public MemoryBoard()

### Method Detail

#### getIdAt

    public java.lang.String getIdAt(FLocation flocation)

Specified by:
  `getIdAt` in class `Board`

#### getFactionAt

    public Faction getFactionAt(FLocation flocation)

Specified by:
  `getFactionAt` in class `Board`

#### setIdAt

    public void setIdAt(java.lang.String id,
                        FLocation flocation)

Specified by:
  `setIdAt` in class `Board`

#### setFactionAt

    public void setFactionAt(Faction faction,
                             FLocation flocation)

Specified by:
  `setFactionAt` in class `Board`

#### removeAt

    public void removeAt(FLocation flocation)

Specified by:
  `removeAt` in class `Board`

#### getAllClaims

    public java.util.Set<FLocation> getAllClaims(java.lang.String factionId)

Specified by:
  `getAllClaims` in class `Board`

#### getAllClaims

    public java.util.Set<FLocation> getAllClaims(Faction faction)

Specified by:
  `getAllClaims` in class `Board`

#### clearOwnershipAt

    public void clearOwnershipAt(FLocation flocation)

Specified by:
  `clearOwnershipAt` in class `Board`

#### unclaimAll

    public void unclaimAll(java.lang.String factionId)

Specified by:
  `unclaimAll` in class `Board`

#### unclaimAllInWorld

    public void unclaimAllInWorld(java.lang.String factionId,
                                  org.bukkit.World world)

Specified by:
  `unclaimAllInWorld` in class `Board`

#### clean

    public void clean(java.lang.String factionId)

#### isBorderLocation

    public boolean isBorderLocation(FLocation flocation)

Specified by:
  `isBorderLocation` in class `Board`

#### isConnectedLocation

    public boolean isConnectedLocation(FLocation flocation,
                                       Faction faction)

Specified by:
  `isConnectedLocation` in class `Board`

#### hasFactionWithin

    public boolean hasFactionWithin(FLocation flocation,
                                    Faction faction,
                                    int radius)

Checks if there is another faction within a given radius other than Wilderness. Used for HCF feature that requires a 'buffer' between factions.

Specified by:
  `hasFactionWithin` in class `Board`
Parameters:
  `flocation` - - center location.
  `faction` - - faction checking for.
  `radius` - - chunk radius to check.
Returns:
  true if another Faction is within the radius, otherwise false.

#### clean

    public void clean()

Specified by:
  `clean` in class `Board`

#### getFactionCoordCount

    public int getFactionCoordCount(java.lang.String factionId)

Specified by:
  `getFactionCoordCount` in class `Board`

#### getFactionCoordCount

    public int getFactionCoordCount(Faction faction)

Specified by:
  `getFactionCoordCount` in class `Board`

#### getFactionCoordCountInWorld

    public int getFactionCoordCountInWorld(Faction faction,
                                           java.lang.String worldName)

Specified by:
  `getFactionCoordCountInWorld` in class `Board`

#### getMap

    public java.util.ArrayList<mkremins.fanciful.FancyMessage> getMap(FPlayer fplayer,
                                                                      FLocation flocation,
                                                                      double inDegrees)

The map is relative to a coord and a faction north is in the direction of decreasing x east is in the direction of decreasing z

Specified by:
  `getMap` in class `Board`

#### convertFrom

    public abstract void convertFrom(MemoryBoard old)